/* 
 * File:   EqualizerColorWidget.cpp
 * Author: mschoepf
 *
 * Created on May 10, 2013, 8:39 AM
 */

#include "EqualizerColorWidget.h"

EqualizerColorWidget::EqualizerColorWidget(QWidget *parent)
	: QWidget (parent)
{
    setBackgroundRole(QPalette::Base);
    setAutoFillBackground(true);

    e_level = 0;
    e_color = Qt::green;
    setMinimumHeight(30);
    setMaximumHeight(30);
    setMinimumWidth(200);
}

void
EqualizerColorWidget::paintEvent(QPaintEvent * /* event */)
 {
     QPainter painter (this);

     painter.setPen(Qt::black);
     painter.drawRect(QRect(painter.viewport().left()+10,
                            painter.viewport().top()+10,
                            painter.viewport().right()-20,
                            painter.viewport().bottom()-20));
     if (e_level == 0.0)
         return;

     painter.setPen(e_color);

     int pos = ((painter.viewport().right()-20)-(painter.viewport().left()+11))*(e_level / 75.0);
     for (int i = 0; i < 10; ++i) {
         int x1 = painter.viewport().left()+11;
         int y1 = painter.viewport().top()+10+i;
         int x2 = painter.viewport().left()+20+pos;
         int y2 = painter.viewport().top()+10+i;
         if (x2 < painter.viewport().left()+10)
             x2 = painter.viewport().left()+10;

         painter.drawLine(QPoint(x1, y1),QPoint(x2, y2));
     }
 }

void
EqualizerColorWidget::setColor(QColor color)
{
	e_color = color;
}

void
EqualizerColorWidget::setLevel(float value)
{
	e_level = value;
	//std::cerr << "New value received: " << value << std::endl;
	repaint();
}
