/* 
 * File:   jsgfParserTest.cpp
 * Author: mschoepf
 *
 * Created on June 2, 2013, 6:00 PM
 */

#define JSGFPARSER_DEBUG 1
#include "JsgfParser.h"
#include "dynamicParser.h"
#include <iostream>
#include <string>
#include <fstream>

    int
main(int argc, char** argv) {

    std::string s ("Moper");
        /*
    stringtest<std::string::const_iterator> myStringtest;
    std::string attr;
    qi::phrase_parse((std::string::const_iterator)s.begin(),(std::string::const_iterator)s.end(),myStringtest,ascii::space,attr);
    std::cout << attr << std::endl;*/
    std::vector<qi::rule<std::string::iterator,std::string(), qi::ascii::space_type>* > rules;
    //rules.push_back (new )
    
    if (argc < 2) {
        std::cout << "Usage: " << argv[0] << " <filename.jsgf>" << std::endl;
        return -1;
    }
    std::ifstream input(argv[1], std::ifstream::in);
    if (!input.is_open()) {
        std::cerr << "Could not open file: " << argv[1] << std::endl;
    }
    std::string storage; // We will read the contents here.
    input.unsetf(std::ios::skipws); // No white space skipping!
    std::copy(
            std::istream_iterator<char>(input),
            std::istream_iterator<char>(),
            std::back_inserter(storage));
    jsgfParserTypes::GrammarT myGrammar;
    jsgfParserRuleGenerator<std::string::const_iterator> myJsgfParser;
    std::string::const_iterator iter = storage.begin();
    std::string::const_iterator end = storage.end();
    bool success = qi::phrase_parse(iter, end, myJsgfParser, ascii::space, myGrammar);
    if (success && iter == end) {
        std::cout << "-------------------------\n";
        std::cout << "Parsing succeeded\n";
        std::cout << "-------------------------\n";
    } else {
        std::string::const_iterator some = iter + 30;
        std::string context(iter, (some > end) ? end : some);
        std::cout << "-------------------------\n";
        std::cout << "Parsing failed\n";
        std::cout << "stopped at: \": " << context << "...\"\n";
        std::cout << "-------------------------\n";
        return 1;
    }
    if (myJsgfParser.sanitizeCheckGrammar(myGrammar,true))
    {
        std::cout << "JSGF check success" << std::endl;
    }
    else
    {
        std::cout << "JSGF check FAILED" << std::endl;
        return 1;
    }
    std::cout << "My grammars Name is: " << myGrammar.name << " and the first rules name is " << myGrammar.rules.at(0).name << std::endl;
    if (myJsgfParser.generateRules(myGrammar))
    {
        std::cout << "JSGF rules generated" << std::endl;
    }
    else
    {
        std::cout << "JSGF rule generation FAILED" << std::endl;
        return 1;
    }
    std::vector<jsgfParserTypes::ruleTPtr> myRules = myJsgfParser.getRules();
    dynamicParser<std::string::iterator> myDynamicParser (myRules);
    std::string st ("this is a task");
    while (0 != st.compare(""))
    {
        getline(std::cin,st);
        std::string::iterator ststart = st.begin();
        std::string::iterator stend = st.end();
        std::vector<std::string> attr;
        //std::cin >> st;
        bool dynSucc = boost::spirit::qi::phrase_parse(ststart,stend, myDynamicParser, boost::spirit::qi::ascii::space,attr);
        if (dynSucc)
        {
            if (ststart != stend)
            {
                std::cout << "'" << st << "' parsed PARTLY successfully "<< std::endl;
                std::cout << "Leftover: '" << std::string().assign(ststart,stend) << "'" << std::endl;
            }
            else
                std::cout << "'" << st << "' parsed successfully "<< std::endl;
            std::cout << "Resultvector: ";
            for (std::vector<std::string>::iterator it=attr.begin();it != attr.end();it++)
                std::cout << "[" << *it << "] ";
            std::cout << std::endl;
        }
        else
            std::cout << "'" << st << "' not part of the grammar" <<  std::endl;
    }
    return 0;
}
    
   
    