/* 
 * File:   simpleDoubleThresholdSegmenter.h
 * Author: mschoepf
 *
 * Created on May 15, 2013, 4:27 PM
 */

#ifndef SIMPLEDOUBLETHRESHOLDSEGMENTER_H
#define	SIMPLEDOUBLETHRESHOLDSEGMENTER_H

#include <QObject>
#include <QWidget>
#include <QLayout>
#include <QHBoxLayout>
#include <QGroupBox>
#include <QSpinBox>
#include <QLabel>
#include <QPushButton>
#include <boost/shared_ptr.hpp>
#include <boost/make_shared.hpp>

#include "AlsaMicGrabber.h"

class simpleDoubleThresholdSegmenter : public QWidget{
    
    Q_OBJECT
    
public:
    simpleDoubleThresholdSegmenter();
    simpleDoubleThresholdSegmenter(unsigned int startDb, unsigned int uttDb, unsigned int maxPause, unsigned int timeout);
    virtual ~simpleDoubleThresholdSegmenter();
    void setStartThreshold (float threshold);
    void setUttThreshold (float threshold);
    void setMaxPause (unsigned int samples);
    void setTimeout (unsigned int samples);
    float getStartThreshold ();
    float getUttThreshold();
    unsigned int getMaxPause();
    unsigned int getTimeout();
private:
    float startThreshold;
    float uttThreshold;    
    unsigned int maxPause;
    unsigned int maxPauseInSamples;
    unsigned int timeout;
    unsigned int timeoutInSamples;
    unsigned int lengthThisSample;
    unsigned int lengthBelowUtt;
    unsigned int stable[3];
    static const unsigned int sampleSize = ALSAMICGRABBER_SAMPLESIZE;
    static const unsigned int sampleRate = ALSAMICGRABBER_SAMPLERATE;
    boost::shared_ptr<QHBoxLayout> mainLayout;
    boost::shared_ptr<QGroupBox> groupBox;
    boost::shared_ptr<QHBoxLayout> groupBoxLayout;
    boost::shared_ptr<QLabel> startThresholdLabel;
    boost::shared_ptr<QLabel> uttThresholdLabel;
    boost::shared_ptr<QLabel> pauseLabel;
    boost::shared_ptr<QLabel> timeoutLabel;
    boost::shared_ptr<QSpinBox> startThresholdSpinBox;
    boost::shared_ptr<QSpinBox> uttThresholdSpinBox;
    boost::shared_ptr<QSpinBox> pauseSpinBox;
    boost::shared_ptr<QSpinBox> timeoutSpinBox;
    boost::shared_ptr<QPushButton> activateSettingsButton;
    int level;
    void setupUI();
public slots:
    void getDBandClipped (float db, bool clipped);
    void checkUttOnStart(int i);
    void checkStartOnUtt(int i);
    void setVariables();
signals:
    void uttStart();
    void uttEnd();
    void uttDiscard();
};

#endif	/* SIMPLEDOUBLETHRESHOLDSEGMENTER_H */

