/* 
 * File:   dataRingBuffer.cpp
 * Author: mschoepf
 * 
 * Created on June 18, 2013, 12:11 PM
 */

#include "dataRingBuffer.h"

const size_t dataRingBuffer::capacity = DATARINGBUFFER_DEFAULTSIZE;

dataRingBuffer::dataRingBuffer() {
    soundChunkBuffer = boost::make_shared<boost::circular_buffer<AlsaSoundChunkT> > (capacity);
}

void
dataRingBuffer::push_back(const AlsaSoundChunkT& asc)
{
    boost::unique_lock<boost::mutex> lock (soundChunkBufferinUse);
    soundChunkBuffer->push_back(asc);
}

std::vector<AlsaSoundChunkT>
dataRingBuffer::getLastNChunks(const unsigned int& n)
{
    size_t lengthToReallyGet = n;    
    size_t counter=0;
    if (n > soundChunkBuffer->capacity())
        lengthToReallyGet = soundChunkBuffer->capacity();    
    if (soundChunkBuffer->size() < n)
        lengthToReallyGet = soundChunkBuffer->size();            
    std::vector<AlsaSoundChunkT> result;
    {
        boost::unique_lock<boost::mutex> lock (soundChunkBufferinUse);        
        for (boost::circular_buffer<AlsaSoundChunkT>::const_reverse_iterator rit=soundChunkBuffer->rbegin(); counter < lengthToReallyGet; rit++, counter++)
        {
                result.push_back(*rit);
        }
    }
    return result;
}

dataRingBuffer::~dataRingBuffer() {
}

