/* 
 * File:   dataRingBuffer.h
 * Author: mschoepf
 *
 * Created on June 18, 2013, 12:11 PM
 */

#ifndef DATARINGBUFFER_H
#define	DATARINGBUFFER_H
#include <boost/circular_buffer.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/make_shared.hpp>
#include "defaults.h"
#include "AlsaMicGrabber.h"
#include <boost/thread/mutex.hpp>


class dataRingBuffer {
public:
    dataRingBuffer();
    virtual ~dataRingBuffer();
    void push_back(const AlsaSoundChunkT &asc);
    std::vector<AlsaSoundChunkT> getLastNChunks (const unsigned int &n);
private:
    const static size_t capacity;
    boost::shared_ptr<boost::circular_buffer<AlsaSoundChunkT> > soundChunkBuffer;
    boost::mutex soundChunkBufferinUse;
};

#endif	/* DATARINGBUFFER_H */

