/* 
 * File:   dynamicParser.h
 * Author: mschoepf
 *
 * Created on June 8, 2013, 6:30 PM
 */

#ifndef DYNAMICPARSER_H
#define	DYNAMICPARSER_H

#include <boost/spirit/include/qi.hpp>
#include <boost/spirit/include/phoenix_core.hpp>
#include <boost/spirit/include/phoenix_operator.hpp>
#include <boost/spirit/include/phoenix_object.hpp>
#include <boost/spirit/include/phoenix_fusion.hpp>
#include <boost/spirit/include/phoenix_stl.hpp>
#include <iostream>
#include <string>

namespace qi = boost::spirit::qi;
namespace px = boost::phoenix;
namespace ascii = boost::spirit::ascii;

template <typename Iterator>
struct dynamicParser : qi::grammar<Iterator,std::vector<std::string>(), boost::spirit::ascii::space_type> {
    dynamicParser (std::vector<qi::rule<Iterator,std::vector<std::string>(), qi::ascii::space_type>* > rules) : dynamicParser::base_type(startRule) {
        rulestack = rules;
        startRule = *(rulestack.at(0));
        std::cout << "Startrule name: " << startRule.name() << std::endl;
#ifdef JSGFPARSER_DEBUG
	for (unsigned long int i=0; i < rulestack.size();i++)
	  qi::debug(*rulestack.at(i));
	qi::debug(startRule);
#endif
        qi::on_error<qi::fail>
        (
            startRule
            , std::cout
                << px::val("Error! Expecting ")
                << qi::_4                               // what failed?
                << px::val(" here: \"")
                << px::construct<std::string>(qi::_3, qi::_2)   // iterators to error-pos, end
                << px::val("\"")
                << std::endl
        );
    }
    std::vector<qi::rule<Iterator,std::vector<std::string>(),qi::ascii::space_type>* > rulestack;
    qi::rule<Iterator,std::vector<std::string>(), qi::ascii::space_type> startRule;
    
};



#endif	/* DYNAMICPARSER_H */

