/*
 * measureDb.cpp
 *
 *  Created on: May 30, 2012
 *      Author: mschoepf
 */

#include "measureDb.h"


measureDbMainWindow::measureDbMainWindow(QWidget* parent) : QMainWindow (parent)
{
	baseFrame = new QFrame(this);
	baseFrame->setGeometry (0, 0, 450, 450);
	eqHBoxLayout = new QHBoxLayout(baseFrame);
	ew = new EqualizerWidget();
	eqHBoxLayout->addWidget(ew);
	dbLabel = new QLabel();
	dbLabel->setText(QString ("0.0 db"));
	eqHBoxLayout->addWidget(dbLabel);
	QObject::connect(&amg,SIGNAL ( updated_dB_and_clipped(float, bool) ), this, SLOT (update_eq (float, bool) ));
}

measureDbMainWindow::~measureDbMainWindow()
{
	QObject::disconnect(&amg, SIGNAL( updated_dB_and_clipped(float, bool) ), this, SLOT (update_eq (float, bool) ));
	delete ew;
	delete eqHBoxLayout;
	delete baseFrame;
}


void
measureDbMainWindow::update_eq(float val, bool clipped)
{
	ew->setClipped(clipped);
	ew->setLevel(val);
	QString s;
	s.setNum(val,'f',2);
	s.append (" db");
	dbLabel->setText(s);
}

int
main (int argc, char** argv)
{
	QApplication myapp (argc,argv);
	measureDbMainWindow w;
	w.setGeometry(200,100,450,450);
	w.show();



	//QLabel *mylabel = new QLabel("NoiseDetector",ew);
	//mylabel->setGeometry(30,40,400,50);
	//mylabel->setFont(QFont("Times"));

	//eqHBoxLayout->addWidget(mylabel,0,Qt::AlignTop);

	{
	//AlsaMicGrabber amg;
	//boost::this_thread::sleep(boost::posix_time::seconds(2));
	}
	return myapp.exec();
}


