/* 
 * File:   publishRsb.cpp
 * Author: mschoepf
 * 
 * Created on June 17, 2013, 1:09 PM
 */

#include "publishRsb.h"

boost::shared_ptr<rsb::converter::XOPConverter> publishRsb::myXopConverter;
boost::mutex publishRsb::myMutex;

publishRsb::publishRsb(const std::string &scope) : scope(scope) {
    if (myXopConverter.use_count() < 1){
        myXopConverter = boost::make_shared<rsb::converter::XOPConverter>();
        rsb::converter::converterRepository<std::string>()->registerConverter(myXopConverter);
    }
    rsb::Factory &factory = rsb::getFactory();
    myInformer = factory.createInformer<rsb::transport::XOP> (scope);
    
}

void
publishRsb::publishMessage(QString message)
{
    std::string temp = message.toStdString();
    boost::unique_lock<boost::mutex> lock (myMutex);
    boost::shared_ptr<rsb::transport::XOP> myData = boost::make_shared<rsb::transport::XOP>(temp);
    myInformer->publish(myData);
}


publishRsb::~publishRsb() {
}

