/* 
 * File:   publishRsb.h
 * Author: mschoepf
 *
 * Created on June 17, 2013, 1:09 PM
 */

#ifndef PUBLISHRSB_H
#define	PUBLISHRSB_H

#include <QObject>
#include <boost/shared_ptr.hpp>
#include <boost/make_shared.hpp>
#include <boost/thread/mutex.hpp>
#include <rsb/Factory.h>
#include <rsc/rscexports.h>
#include <rsb/converter/Repository.h>
#include <rsb/converter/ProtocolBufferConverter.h>
#include <rsbxml0.9/rsbxml/XOPConverter.h>
#include <rsbxml0.9/rsbxml/XOP.h>



class publishRsb : public QObject{
    
    Q_OBJECT
    
public:
    static boost::mutex myMutex;
    publishRsb(const std::string &scope);
    virtual ~publishRsb();
public slots:
    void publishMessage(QString message);
private:
    static boost::shared_ptr<rsb::converter::XOPConverter> myXopConverter;
    boost::shared_ptr<rsb::Informer<rsb::transport::XOP> > myInformer;
    std::string scope;    
};

#endif	/* PUBLISHRSB_H */

