/* 
 * File:   rsbRemoteReceiver.h
 * Author: mschoepf
 *
 * Created on June 17, 2013, 2:54 PM
 */

#ifndef RSBREMOTERECEIVER_H
#define	RSBREMOTERECEIVER_H

#include <QObject>

#include <rsb/Factory.h>
#include <rsb/patterns/Server.h>
#include <boost/thread.hpp>
#include <boost/thread/condition_variable.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/make_shared.hpp>

class rsbCallbackReceiver : public rsb::patterns::Server::Callback<std::string,std::string> {
    public:
        boost::condition_variable condWaitForRemote;
        boost::mutex myMutex;        
        rsbCallbackReceiver();
        boost::shared_ptr<std::string> call(const std::string& /*methodName*/,boost::shared_ptr<std::string> input);
        bool hasToggled();
        int getState();
        void setState(int state);
        void resetToggle();
    private:
        int state;
        bool toggle;
        
};

class rsbRemoteReceiver : public QObject {
    
    Q_OBJECT
    
public:
    rsbRemoteReceiver(const std::string &scope);    
    virtual ~rsbRemoteReceiver();
    void runner();
    
    
public slots:
    void overwriteEnable();
    void overwriteDisable();
    
private:           
    rsb::patterns::ServerPtr server;
    boost::shared_ptr<rsbCallbackReceiver> myReceiver;    
    std::string scope;
    boost::shared_ptr<boost::thread> remoteListenThread;
signals:
    void remoteDisable();
    void remoteEnable();
    
};

#endif	/* RSBREMOTERECEIVER_H */

